/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-26 16:27:34 UTC)
 * on 2013-07-15 at 20:26:58 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.orkut.model;

/**
 * Model definition for CommunityMessageList.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Orkut API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class CommunityMessageList extends com.google.api.client.json.GenericJson {

  /**
   * The value of pageToken query parameter in community_messages.list request to get the first
   * page.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String firstPageToken;

  /**
   * List of messages retrieved.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<CommunityMessage> items;

  /**
   * Identifies this resource as a collection of community messages. Value:
   * "orkut#communityMessageList"
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The value of pageToken query parameter in community_messages.list request to get the last page.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String lastPageToken;

  /**
   * The value of pageToken query parameter in community_messages.list request to get the next page,
   * if there are more to retrieve.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String nextPageToken;

  /**
   * The value of pageToken query parameter in community_messages.list request to get the previous
   * page, if there are more to retrieve.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String prevPageToken;

  /**
   * The value of pageToken query parameter in community_messages.list request to get the first
   * page.
   * @return value or {@code null} for none
   */
  public java.lang.String getFirstPageToken() {
    return firstPageToken;
  }

  /**
   * The value of pageToken query parameter in community_messages.list request to get the first
   * page.
   * @param firstPageToken firstPageToken or {@code null} for none
   */
  public CommunityMessageList setFirstPageToken(java.lang.String firstPageToken) {
    this.firstPageToken = firstPageToken;
    return this;
  }

  /**
   * List of messages retrieved.
   * @return value or {@code null} for none
   */
  public java.util.List<CommunityMessage> getItems() {
    return items;
  }

  /**
   * List of messages retrieved.
   * @param items items or {@code null} for none
   */
  public CommunityMessageList setItems(java.util.List<CommunityMessage> items) {
    this.items = items;
    return this;
  }

  /**
   * Identifies this resource as a collection of community messages. Value:
   * "orkut#communityMessageList"
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Identifies this resource as a collection of community messages. Value:
   * "orkut#communityMessageList"
   * @param kind kind or {@code null} for none
   */
  public CommunityMessageList setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The value of pageToken query parameter in community_messages.list request to get the last page.
   * @return value or {@code null} for none
   */
  public java.lang.String getLastPageToken() {
    return lastPageToken;
  }

  /**
   * The value of pageToken query parameter in community_messages.list request to get the last page.
   * @param lastPageToken lastPageToken or {@code null} for none
   */
  public CommunityMessageList setLastPageToken(java.lang.String lastPageToken) {
    this.lastPageToken = lastPageToken;
    return this;
  }

  /**
   * The value of pageToken query parameter in community_messages.list request to get the next page,
   * if there are more to retrieve.
   * @return value or {@code null} for none
   */
  public java.lang.String getNextPageToken() {
    return nextPageToken;
  }

  /**
   * The value of pageToken query parameter in community_messages.list request to get the next page,
   * if there are more to retrieve.
   * @param nextPageToken nextPageToken or {@code null} for none
   */
  public CommunityMessageList setNextPageToken(java.lang.String nextPageToken) {
    this.nextPageToken = nextPageToken;
    return this;
  }

  /**
   * The value of pageToken query parameter in community_messages.list request to get the previous
   * page, if there are more to retrieve.
   * @return value or {@code null} for none
   */
  public java.lang.String getPrevPageToken() {
    return prevPageToken;
  }

  /**
   * The value of pageToken query parameter in community_messages.list request to get the previous
   * page, if there are more to retrieve.
   * @param prevPageToken prevPageToken or {@code null} for none
   */
  public CommunityMessageList setPrevPageToken(java.lang.String prevPageToken) {
    this.prevPageToken = prevPageToken;
    return this;
  }

  @Override
  public CommunityMessageList set(String fieldName, Object value) {
    return (CommunityMessageList) super.set(fieldName, value);
  }

  @Override
  public CommunityMessageList clone() {
    return (CommunityMessageList) super.clone();
  }

}
